'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports['default'] = createDumbComponent;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _utilsGetDisplayName = require('../utils/getDisplayName');

var _utilsGetDisplayName2 = _interopRequireDefault(_utilsGetDisplayName);

var _lodash = require('lodash');

function createDumbComponent(DecoratedComponent, specs) {
  var initialArgs = specs.initialArgs;
  var fragments = specs.fragments;

  var currentArgs = _extends({}, initialArgs);
  var displayName = 'DumbComponent(' + (0, _utilsGetDisplayName2['default'])(DecoratedComponent) + ')';

  return (function (_Component) {
    _inherits(_class, _Component);

    _createClass(_class, null, [{
      key: 'getFragment',
      value: function getFragment(key) {
        (0, _invariant2['default'])((0, _lodash.isString)(key), 'You cant call getFragment(key: string) without string key in %s', displayName);

        return '... on ' + fragments[key](currentArgs).replace(/\s+/g, ' ').trim();
      }
    }, {
      key: 'displayName',
      value: displayName,
      enumerable: true
    }, {
      key: 'DecoratedComponent',
      value: DecoratedComponent,
      enumerable: true
    }, {
      key: 'contextTypes',
      value: {
        update: _react.PropTypes.func.isRequired
      },
      enumerable: true
    }]);

    function _class(props, context) {
      _classCallCheck(this, _class);

      _get(Object.getPrototypeOf(_class.prototype), 'constructor', this).call(this, props, context);
      this.state = {
        args: currentArgs
      };
      currentArgs = this.state.args;
      //this.context.update();
    }

    _createClass(_class, [{
      key: 'componentDidMount',
      value: function componentDidMount() {
        console.log('child mount');
      }
    }, {
      key: 'setArgs',
      value: function setArgs(nextArgsSlice) {
        currentArgs = _extends({}, currentArgs, nextArgsSlice);
        console.log(nextArgsSlice);
        this.setState({ args: nextArgsSlice });
        this.context.update();
      }
    }, {
      key: 'render',
      value: function render() {
        return _react2['default'].createElement(DecoratedComponent, _extends({}, this.props, {
          args: this.state.args,
          setArgs: this.setArgs.bind(this) }));
      }
    }]);

    return _class;
  })(_react.Component);
}

module.exports = exports['default'];